#pragma rtGlobals=1		// Use modern global access method.
#pragma IgorVersion = 4.0
#pragma version = 3.0



Function Load_multiple_Stripes(range,fmt)
	// load multiple stripes of one kind (must call separately for short and long)
	String range						// range of stripes to load  ( ="1")
	String fmt							// change this to give format of LTP file name , short="ICE4B-%d.SLP"

	if (strlen(range)<1)
		range = "1"
	endif
	if (strlen(fmt)<1)
		fmt = "ICE4A-%d.SLP"
	endif

	Prompt range, "numerical range of stripes to fit"
	Prompt fmt, "format (used in sprintf) to make LTP file name, eg. 'ICE4A-%d.SLP', or none"
	DoPrompt "range to fit", range, fmt
	if (V_flag)
		return 1
	endif
	range = expandRange(range)
	if (stringmatch(fmt,"none") || (strlen(fmt)<1))
		DoAlert 0, "No file name given"
		return 1
	endif

	String fldrSav= GetDataFolder(1)
	String fldr, fileName
	Variable n, i=0
	do
		n = str2num(StringFromList(i, range))
		if (numtype(n))
			break
		endif
		fldr = "root:stripe"+num2istr(n)
		NewDataFolder /O/S $fldr							// uses the old folder name if it exists
		sprintf fileName, fmt, n
		Load_APS_LTPslopeFile(fileName)
		SetDataFolder fldrSav
		i += 1
	while (1)

	SetDataFolder fldrSav
	printf "\r\r\r"
End



Function Fit_multiple_stripes(range,fitType)
	String range				// range of stripes to fit  (=1)
	Variable fitType				// =NumVarOrDefault("root:Packages:KBmirror:fit_s2", 3)
	if (strlen(range)<1)
		range = "1"
	endif
	Variable depositToo=2
	Variable optimizeType=1// type of optimization: 1=slope at 0,  2=total area,  3=max thickness
	Prompt range, "numerical range of stripes to fit"
	Prompt fitType, "type of fit", popup, "vary s2;Fix s2;Fix s2 & xoffset;circle"
	Prompt depositToo, "also make deposition profile", popup, "No;Yes"
	Prompt optimizeType, "object of minimization if fitting" popup, "slope at 0;total area;max thickness"
	DoPrompt "range to fit", range, fitType, depositToo, optimizeType
	if (V_flag)
		return 1
	endif
	range = expandRange(range)
	depositToo -= 1

	String fldrSav= GetDataFolder(1)
	String fldr
	String fitGraph=""
	String heightGraph="none"
	String depositGraph="none"
	String Scorelate = ""
	String yname,xname
	String str1,str2
	String Sres, spotError
	Variable s1,s2
	String wnote, mm
	Variable p1,p2
	Variable length
	Variable n,i=0
	do
		n = str2num(StringFromList(i, range))
		if (numtype(n))
			break
		endif
		fldr = "stripe"+num2istr(n)
		SetDataFolder $fldr
		print "     in data folder '"+fldr+"'"
		yname = StringFromList(0, WaveList("s*Rad",";",""))
		xname = StringFromList(0, WaveList("s*RadX",";",""))
		if (strlen(yname) && strlen(xname))
			length = NumberByKey("length",note($yname),"=")
			mm = num2istr(round(length*1000))
			s1 = SelectNumber(stripeType(length)-2, 36.5, 64.5)
			s2 = SelectNumber(stripeType(length)-2, 0.06, 0.13)
			Fit_a_Stripe(yname,xname,s1,s2,fitType,"stripe"+num2istr(n))
			Scorelate = ""
			if (exists("M_Covar"))
				Wave M_Covar=M_Covar
				Duplicate/O M_Covar, $Scorelate				// make the correlation matrix
				Wave corelate=$Scorelate
				corelate = M_Covar[p][q]/sqrt(M_Covar[p][p]*M_Covar[q][q])
				KillWaves M_Covar
			endif
			Sres = "Res_"+yname
			// first make the spot error
//			String mm=num2istr(str2num(yname[1,10]))
			spotError = "spotSize"+mm+"mm"
			Duplicate/O $Sres $spotError
			Wave res = $Sres
			Wave spot = $spotError
			Wave radX = $xname
			spot = spotErrorCircle(radX[p],res[p],s2)
			SetScale d 0,0,"m", $spotError
			// done making spot error  
			DisplayOneFit("fit_"+yname,Sres,spotError,Scorelate,"stripe"+num2istr(n))
			SetWindow kwTopWin note="fitLTP"
			fitGraph = WinName(0,1)
			heightGraph = "none"
			depositGraph = "none"
			if (depositToo)
				wnote=note($("fit_"+yname))
				s1 = NumberByKey("s1",wnote,"=")
				p1 = NumberByKey("range0",wnote,"=")
				p2 = NumberByKey("range1",wnote,"=")
				length = NumberByKey("length",wnote,"=")
				mm = num2istr(round(length*1000))
				if (!FindDepositionProfile(yname,s1,s2,.006,p1,p2,optimizeType))
				heightGraph = DisplayHeightProfile(yname,xname)
				if (stripeType(length)==2)						// a standard short mirror
					str1 = "none"
					str2 = "deposit"+mm+"mm"
				else
					str1 = "deposit"+mm+"mm"
					str2 = "none"
				endif
				depositGraph = Display_BothDepositProfiles(str1,str2)
				endif
			endif
			DoUpdate
			AppendPlotsToNotebook(fitGraph,heightGraph,depositGraph)
			printf "\r"
		endif

		SetDataFolder fldrSav
		i += 1
	while (1)
	printf "\r"
End



Function Fit_multiple_stripesPairs(range,fitType)
	String range				// range of stripes to fit  (=1)
	Variable fitType				// =NumVarOrDefault("root:Packages:KBmirror:fit_s2", 3)
	if (strlen(range)<1)
		range = "1"
	endif
	Prompt range, "numerical range of stripes to fit"
	Prompt fitType, "type of fit", popup, "vary s2;Fix s2;Fix s2 & xoffset;circle"

	DoPrompt "range to fit", range, fitType
	if (V_flag)
		return 1
	endif
	range = expandRange(range)

	String fldrSav= GetDataFolder(1)
	String fldr
	String graphLong="", graphShort=""
	String corelate = ""
	String Sres, spotError
	Variable s2
	Variable n,i=0
	do
		n = str2num(StringFromList(i, range))
		if (numtype(n))
			break
		endif
		fldr = "stripe"+num2istr(n)
		SetDataFolder $fldr
		print "     in data folder '"+fldr+"'"

		if (exists("longRad") && exists("longRadX"))
			s2 = 0.130
			Fit_a_Stripe("longRad","longRadX",36.5,s2,fitType,"stripe"+num2istr(n))
			corelate = ""
			if (exists("M_Covar"))
				Wave M_Covar=M_Covar
				Duplicate/O M_Covar, long_correlate				// make the correlation matrix
				long_correlate = M_Covar[p][q]/sqrt(M_Covar[p][p]*M_Covar[q][q])
				corelate = "long_correlate"
				KillWaves M_Covar
			endif
			Sres = "Res_longRad"
			// first make the spot error
			spotError = "spotSizeLong"
			Duplicate/O $Sres $spotError
			Wave res = $Sres
			Wave spot = $spotError
			Wave radX = longRadX
			spot = spotErrorCircle(radX[p],res[p],s2)
			SetScale d 0,0,"m", $spotError
			// done making spot error  
			DisplayOneFit("fit_longRad",Sres,spotError,corelate,"stripe"+num2istr(n))
			SetWindow kwTopWin note="fitLTP;long"
			graphLong = WinName(0,1)
			printf "\r"
		endif

		if (exists("shortRad") && exists("shortRadX"))
			s2 = 0.060
			Fit_a_Stripe("shortRad","shortRadX",36.5,s2,fitType,"stripe"+num2istr(n))
			corelate = ""
			if (exists("M_Covar"))
				Wave M_Covar=M_Covar
				Duplicate/O M_Covar, short_correlate			// make the correlation matrix
				short_correlate = M_Covar[p][q]/sqrt(M_Covar[p][p]*M_Covar[q][q])
				corelate = "short_correlate"
				KillWaves M_Covar
			endif
			Sres = "Res_shortRad"
			// first make the spot error
			spotError = "spotSizeShort"
			Duplicate/O $Sres $spotError
			Wave res = $Sres
			Wave spot = $spotError
			Wave radX = shortRadX
			spot = spotErrorCircle(radX[p],res[p],s2)
			SetScale d 0,0,"m", $spotError
			// done making spot error
			DisplayOneFit("fit_shortRad",Sres,spotError,corelate,"stripe"+num2istr(n))
			SetWindow kwTopWin note="fitLTP;short"
			graphShort = WinName(0,1)
			printf "\r  \r"
		endif

		DoUpdate
		AddLongShortToNotebook(graphLong,graphShort)
		SetDataFolder fldrSav
		i += 1
	while (1)
	printf "\r"
End


Function Save_multiple_Depositions(range)			// save deposition profiles for multiple files
	String range				// range of stripes to save
	if (strlen(range)<1)
		range = "1"
	endif
	Prompt range, "numerical range of stripes to fit"
	DoPrompt "range to save", range
	if (V_flag)
		return 1
	endif
	range = expandRange(range)
	String deposit
	String fldrSav= GetDataFolder(1)
	String fldr
	String yname
	Variable length
	String mm

	Variable n,i=0
	do
		n = str2num(StringFromList(i, range))
		if (numtype(n))
			break
		endif
		fldr = "stripe"+num2istr(n)
		SetDataFolder $fldr
		print "     in data folder '"+fldr+"'"
		yname = StringFromList(0, WaveList("s*Rad",";",""))
		if (strlen(yname) < 1)
			printf "Cannot find slope wave '%s:%s'\r", getdatafolder(1),yname
			break
		endif
		length = NumberByKey("length",note($yname),"=")
		if (numtype(length))
			printf "Cannot find length in '%s:%s'\r", getdatafolder(1),yname
			break
		endif
		mm = num2istr(round(length*1000))
		deposit = "deposit"+mm+"mm"

		if (exists(deposit)==1)
			MakeDepositionForMetrology($deposit)
			printf "saved file %s%s\r", getdatafolder(1),deposit
		else
			Abort "deposition profile named '"+deposit+"' does not exist"
		endif
		SetDataFolder fldrSav
		i += 1
	while (1)
End


Function AddLongShortToNotebook(graphLong,graphShort)
	String graphLong,graphShort					// names of graph windows to print
	PauseUpdate
	String nb="KB_Mirror_Results"
	if (strlen(WinList(nb, ";", "WIN:16")) != (strlen(nb)+1))
		NewNotebook /F=1 /N=$nb /V=0/K=3
		Notebook $nb statusWidth=238, pageMargins={72,72,72,72}, showRuler=0
		Notebook $nb newRuler=Normal, justification=0, margins={0,0,468}, spacing={0,0,0}, rulerDefaults={"Helvetica",12,0,(0,0,0)}
		Notebook $nb, text="Mirrors from file \""+igorinfo(1)+"\",   "
		Notebook $nb, specialChar={3,0,"" }, text=",   ", specialChar={5,0,"" },text="\r\r"

		Notebook $nb,text="Note, the quoted FWHM will be zero if the fit is perfect "
		Notebook $nb,text="(This implies that a cylinder will focus perfectly).  "
		Notebook $nb,text="The FWHM is just intended to show the significance of "
		Notebook $nb,text="the slope errors.\r"
	else
		Notebook KB_Mirror_Results, selection={endOfFile, endOfFile }	// ensure at EOF
		Notebook $nb, specialChar={1,0,"" }		// insert page break
	endif

	Notebook KB_Mirror_Results, selection={endOfFile, endOfFile }	// ensure at EOF

	if (strlen(graphLong)>0)
		Notebook $nb, frame=0, scaling={50,50}, picture={$graphLong,-1,1}
		Notebook $nb,text="    "
	endif
	if (strlen(graphShort)>0)
		Notebook $nb, frame=0, scaling={50,50}, picture={$graphShort,-1,1}
	endif
End




Static Function/T expandRange(range)
	String range

	Variable i1,i2,i
	String str,out=""
	Variable N=ItemsInList(range,",")
	Variable j=0
	do
		str = StringFromList(j, range, ",")
		// now check str to see if it is a range like "20-23"
		i1 = str2num(str)
		i = strsearch(str,"-",strlen(num2str(i1)))		// position of "-" after first number
		if (i>0)
			i2 = str2num(str[i+1,inf])
			i = i1
			do
				out += num2str(i)+";"
				i += 1
			while (i<=i2)
		else
			out += num2str(i1)+";"
		endif
		j += 1
	while (j<N)
	return out
End
